	Appl	"HexCalc", 'HeXc'
;****************************************************************
;*               HexCalc - The programmers calculator           *
;*                                                              *
;*                                                              *
;*  Written by:  Gary T. Desrosiers                             *
;*               desrosi@pcnet.com                              *
;*               http://www.pcnet.com/~desrosi                  *
;*                                                              *
;*  Date:	 March 10th, 1997                               *
;*                                                              *
;*  Description: HexCalc is a simple calculator for the Pilot   *
;*               that has commonly used programmer type         *
;*               functions including decimal-hex conversions,   *
;*               shifts, negates, etc. Unlike a real calculator *
;*               HexCalc does not do floating point. All        *
;*               operations are on a 32bit integer.             *
;****************************************************************
	include "Pilot.inc"
	include "Startup.inc"

; View source with tabstops set to 8

kidbAIB         equ             $7FFE
kidrAboutAlert  equ		1000
kidmAbout	equ		1002
kidbBMP		equ		1987
kidbCLR 	equ		1988
kidbDEC 	equ		1989
kidbHEX 	equ		1990
kidbEQUAL 	equ		1991
kidbADD 	equ		1992
kidbSUB 	equ		1993
kidbMULT 	equ		1994
kidbDIV 	equ		1995
kidbNEG		equ		1996
kidbLSHIFT	equ		1997
kidbRSHIFT	equ		1998
kidbCE		equ		1999
kidbBMP0	equ		2000
kidbBMP1	equ		2001
kidbBMP2	equ		2002
kidbBMP3	equ		2003
kidbBMP4	equ		2004
kidbBMP5	equ		2005
kidbBMP6	equ		2006
kidbBMP7	equ		2007
kidbBMP8	equ		2008
kidbBMP9	equ		2009
kidbBMPA	equ		2010
kidbBMPB	equ		2011
kidbBMPC	equ		2012
kidbBMPD	equ		2013
kidbBMPE	equ		2014
kidbBMPF	equ		2015
kidrPREF        equ             1
kidrTVER        equ             1
kidrTAIB        equ             1000
kidfMain        equ             1000
kidmMain        equ             1000
keyClear	equ		0
keyDec		equ		1
keyHex		equ		2
keyEqual	equ		3
keyPlus		equ		4
keyMinus	equ		5
keyMult		equ		6
keyDiv		equ		7
keyNEG		equ		8
keyLSHIFT	equ		9
keyRSHIFT	equ		10
keyCE		equ		11
keyNOT		equ		12
;menu commands start with 16
keyAND		equ		16 
keyOR		equ		17
keyXOR		equ		18

;
; a5-relative global variables
;
	        data

op		ds.l	1
key		ds.l	1
operand		ds.l	1
accum		ds.l	1     
DisplayMode 	ds.b 	1
operandAvail	ds.b	1
error		ds.b	1 
DispString	ds.b	32
HexLbl 		dc.b	'Hex',0
DecLbl 		dc.b 	'Dec',0
DisplayOp 	dc.b 	'+-x/'
DisplayOpMenu   dc.b	'AND OR  XOR '
NegIndicator 	dc.b 	'-',0  
ErrorString	dc.b	'Error',0

	        code

proc PilotMain(cmd.w, cmdPBP.l, launchFlags.w)
local   err.w
local   evt.EventType
beginproc
        tst.w   cmd(a6)                 ;sysAppLaunchCmdNormalLaunch is 0
        bne	Return                  ;not a normal launch, bag out
	clr.l	key(a5)
	clr.l	operand(a5)		;clear operand value
	clr.l	accum(a5)		;clear accumulator
	clr.l	op(a5)       
	clr.b	error(a5) 
	clr.b	operandAvail(a5)
	move.b	#1,DisplayMode(a5)	;Initially Decimal
        systrap FrmGotoForm(#kidfMain.w)
EvtLoop
	systrap EvtGetEvent(&evt(a6), #evtWaitForever.w)
        systrap SysHandleEvent(&evt(a6))
        tst.b   d0    
        bne.s   EvtDone
        systrap MenuHandleEvent(&0, &evt(a6), &err(a6))
        tst.b   d0       
        bne.s   EvtDone
        call    ApplicationHandleEvent(&evt(a6))
        tst.b   d0       
        bne.s   EvtDone 
        call    MainFormHandleEvent(&evt(a6))
        tst.b   d0
        bne.s   EvtDone
        systrap FrmGetActiveForm()
        systrap FrmHandleEvent(a0.l, &evt(a6))
EvtDone cmpi.w  #appStopEvent,evt+EventType.eType(a6)
        bne.s   EvtLoop
Return  moveq   #0,d0
endproc


proc ApplicationHandleEvent(pevt.l)
local rect.RectangleType
beginproc
        movea.l pevt(a6),a0             ;a0 = pevt
        cmpi.w  #frmLoadEvent,EventType.eType(a0) ;frmLoadEvent?
        bne.s   AHENotHandled           ;no
        systrap FrmInitForm(EventType.data+frmLoad.formID(a0).w)
        move.l  a0,a3                   ;save a copy of FormPtr for later
        systrap FrmSetActiveForm(a0.l)
        moveq.l #1,d0                   ;event handled
        bra.s   AHEReturn
AHENotHandled
        clr.b   d0
AHEReturn
endproc


proc MainFormHandleEvent(pevt.l)
beginproc
        movem.l a3/d3-d5,-(a7)          ;save registers we're going to trash
        movea.l pevt(a6),a0             ;a0 = pevt
        move.w  EventType.eType(a0),d0
        cmpi.w	#frmOpenEvent,d0
        bne.s   MFH1
	systrap	WinEraseWindow()
;
; Draw the key bitmaps from the bottom of the screen up
;
	move.l  #kidbBMPF,d3		;last resource button
	moveq   #6,d5 ;ypos
col1	moveq   #3,d4 ;xpos
row1	move.l  d5,d1
	mulu.w  #16,d1			;each button is 40x16
	addi.l  #48,d1			;48 = 160-(16*6)
	move.l  d4,d0
	mulu.w	#40,d0
	call    DrawBitmap(d3.w,d0.w,d1.w)
	subq    #1,d3			;decrement resource
	dbeq    d4,row1
	dbeq    d5,col1
	jsr	UpdateDisplay(pc)
        moveq.l #1,d0
        bra     MFHReturn
;
; Handle Menu Event
;
MFH1
        cmpi.w	#menuEvent,d0
        bne.s   MFH2
	cmpi.w	#kidmAbout,EventType.data+menu.itemID(a0)
	bne.s	MFH1A
	systrap	FrmAlert(#kidrAboutAlert.w)	
        moveq.l #1,d0
        bra     MFHReturn
MFH1A	move.w	EventType.data+menu.itemID(a0),d1
	ext.l	d1
	bra	FKM	;function key from menu item

;
; Handle penUpEvent
;
MFH2	cmpi.w	#penUpEvent,d0
	bne.s   MFH3
	move.l	key(a5),d2
	add.l	#kidbCLR,d2		;compute button to draw
	move.l	key(a5),d0
	divu.w  #4,d0			;/4 gets row, col in rem
	move.l	d0,d1
	ext.l	d0			;d0 = row
	swap	d1			;d1 = col
	mulu.w  #16,d0			;*16+48 to position bitmap
	addi.w  #48,d0
	mulu.w  #40,d1			;same for col
	call    DrawBitmap(d2.w,d1.w,d0.w)
	clr.l	key(a5)
        moveq.l #1,d0
        bra     MFHReturn

;
;	Handle penDownEvent
;
MFH3	cmpi.w	#penDownEvent,d0
	bne	MFH4
	move.w  EventType.screenY(a0),d0
	cmpi.w 	#48,d0 			; 7 rows of 16 = 112, (160-112) = 48
	blt	MFHNotHandled
	
	;
	; first draw down bitmap
	;

	ext.l	d0			;extend y to upper word
	subi.w  #48,d0			; (y-38)/16 * 4 + (x/40)
	divu.w  #16,d0			; obtains the button pressed
	mulu.w  #4,d0
	move.w  EventType.screenX(a0),d1
	ext.l	d1
	divu.w  #40,d1
	ext.l	d1
	add.l	d0,d1
	move.l	d1,d0				
	divu.w  #4,d0			;/4 gets row, col in rem
	move.l	d0,d1
	ext.l	d0			;d0 = row
	swap	d1			;d1 = col
	mulu.w  #16,d0			;*16+48 to position bitmap
	addi.l  #48,d0
	mulu.w  #40,d1			;same for col
	call	DrawBitmap(#kidbBMP.w,d1.w,d0.w)

	;
	; end of down bitmap draw
	;

        movea.l pevt(a6),a0             ;a0 is trashed, so reload the pevt
	move.w  EventType.screenY(a0),d0
	cmpi.w	#96,d0			;is it a function key
	blt.s	FunctionKey		;yes, then handle it
	ext.l	d0
	subi.w  #96,d0
	divu.w  #16,d0
	mulu.w  #4,d0
	move.w  EventType.screenX(a0),d1
	ext.l	d1
	divu.w  #40,d1
	add.l	d0,d1
	ext.l	d1
	move.l	d1,d0			;d1 contains keys value
	add.b	#kidbBMP0-kidbCLR,d0
	move.l	d0,key(a5) 		;save keypress for penup event
SimKey	tst.b	operandAvail(a5)	;if no operand
	bne.s	DspSet2
	clr.l	operand(a5)		; then, clear operand
DspSet2	cmpi.b	#1,DisplayMode(a5)
	beq.s	DispDec
	move.l	operand(a5),d0		;Value to display in d0
	lsl.l	#4,d0			;*16 for hex display
	add.l	d1,d0			;add in new keypress
	bra.s	DispSet
DispDec	cmpi.b	#9,d1			;check if invalid keypress
	bgt	KeyNotHandled		;bad key
	move.l	operand(a5),d0		;Value to display
	add.l	d0,d1			;add new key
	add.l	d0,d1			; twice
	lsl.l	#3,d0			;prev value*8
	add.l	d1,d0			;add the two and becomes effective long *10
DispSet	move.l	d0,operand(a5)		;save the new value
	move.b	#1,operandAvail(a5)	;operand is available now
	jsr	UpdateDisplay(pc)	;update the display
	moveq.l #1,d0
        bra     MFHReturn
;
; Function keypresses, CLR, Dec, Hex, =, +, -, x, /, NEG, <<, >>, and CE
;
FunctionKey
	ext.l	d0
	subi.w  #48,d0
	divu.w  #16,d0
	mulu.w  #4,d0
	move.w  EventType.screenX(a0),d1
	ext.l	d1
	divu.w  #40,d1
	add.l	d0,d1
	ext.l	d1  
	move.l	d1,key(a5) 	;save keypress for penup event  
	cmpi.b	#keyDec,d1			;Dec key?
	bne.s	fk1
	move.b	#1,DisplayMode(a5)
	bra	FKDone
fk1	cmpi.b	#keyHex,d1			;Hex key?
	bne.s	fk2
	clr.b	DisplayMode(a5)
	bra	FKDone
fk2	cmpi.b	#keyNEG,d1			;NEG key?
	bne.s	fk3    
	tst.b	operandAvail(a5)
	beq.s	fk2a
	neg.l	operand(a5)
	bra	FKDone
fk2a	neg.l	accum(a5)
	bra	FKDone	
fk3	cmpi.b	#keyCE,d1			;CE key?
	bne.s	fk4	
	clr.b	error(a5)
	tst.b	operandAvail(a5)
	beq.s	fk3a
	clr.l	operand(a5)
	clr.b	operandAvail(a5)
	bra	FKDone
fk3a	clr.l	op(a5)
	bra	FKDone
fk4	cmpi.b	#keyClear,d1			;Clear key?
	bne.s	fk5
	clr.l	op(a5)
	clr.l	operand(a5)
	clr.l	accum(a5)
	clr.b	error(a5)
	bra.s	FKDone
fk5	cmpi.b	#keyNEG,d1			;Neg key?
	bne.s	fk6
	neg.l	operand(a5)
	bra.s	FKDone
fk6	cmpi.b	#keyRSHIFT,d1			;>>?
	bne.s	fk8                  
	tst.b	operandAvail(a5)
	beq.s	fk6a
	move.l	operand(a5),d0
	lsr.l	#1,d0
	move.l	d0,operand(a5)
	bra.s	FKDone        
fk6a	move.l	accum(a5),d0
	lsr.l	#1,d0
	move.l	d0,accum(a5)
	bra.s	FKDone	
fk8	cmpi.b	#keyLSHIFT,d1			;<<?
	bne.s	FKM   
	tst.b	operandAvail(a5)
	beq.s	fk8a
	move.l	operand(a5),d0
	lsl.l	#1,d0
	move.l	d0,operand(a5)
	bra.s	FKDone
fk8a	move.l	accum(a5),d0
	lsl.l	#1,d0
	move.l	d0,accum(a5)
	bra.s	FKDone	
FKM	cmpi.b	#keyNOT,d1			;Not menu item
	bne.s	fk9
	tst.b	operandAvail(a5)
	beq.s	FKMA
	not.l	operand(a5)
	bra.s	FKDone
FKMA	not.l	accum(a5)
	bra.s	FKDone
fk9
	call	PerformOp(d1.l)
	
FKDone	jsr	UpdateDisplay(pc)
	bra.s	MFHReturn
		
MFH4	cmpi.w	#keyDownEvent,d0
	bne.s	MFHNotHandled
	cmpi.w	#'0',EventType.data+keyDown.chr(a0)
	blt.s	KeyNotHandled
	cmpi.w	#'9',EventType.data+keyDown.chr(a0)
	ble.s	KeyOK
	cmpi.w	#'A',EventType.data+keyDown.chr(a0)
	blt.s	KeyNotHandled
	cmpi.w	#'F',EventType.data+keyDown.chr(a0)
	ble.s	KeyOK
	cmpi.w	#'a',EventType.data+keyDown.chr(a0)
	blt.s	KeyNotHandled
	cmpi.w	#'f',EventType.data+keyDown.chr(a0)
	bgt.s	KeyNotHandled
	and.w	#$00df,EventType.data+keyDown.chr(a0)
KeyOK	move.w	EventType.data+keyDown.chr(a0),d1
	ext.l	d1
	sub.b	#'0',d1
	cmpi.b	#9,d1
	ble	SimKey
	sub.b	#7,d1
	bra	SimKey
KeyNotHandled
        systrap SndPlaySystemSound(#sndError.b)
MFHNotHandled
        clr.b   d0
MFHReturn
        moveq.l #1,d0
        movem.l (a7)+,a3/d3-d5
endproc
           
        
; Binary (2 argument) operations   
proc PerformOp(operator.l)
beginproc
	tst.b	error(a5)		;error state?
	bne	PerformOpExit
	tst.b	operandAvail(a5)	;is there an operand available?
	beq	PerformOpExit
	tst.l	op(a5)			;operand?
	bne.s	po1
	move.l	operand(a5),accum(a5)
	bra	PerformOpExit
po1	move.l	op(a5),d0
	cmpi.b	#keyMult,d0		;multiply?
	bne.s	po2
	move.l	accum(a5),d0
	move.l	operand(a5),d1
	muls.w	d1,d0
	move.l	d0,accum(a5)
	bra	PerformOpExit
po2	cmpi.b	#keyDiv,d0		;divide?
	bne.s	po4
	move.l	accum(a5),d0
	move.l	operand(a5),d1
	tst.l	d1			;don't div by zero
	bne.s	po3
	move.b	#1,error(a5)		;set error state
	bra	PerformOpExit
po3	divs.w	d1,d0
	ext.l	d0
	move.l	d0,accum(a5)
	bra	PerformOpExit
po4	cmpi.b	#keyPlus,d0		;add?
	bne.s	po5
	move.l	accum(a5),d0
	add.l	operand(a5),d0
	move.l	d0,accum(a5)
	bra.s	PerformOpExit
po5	cmpi.b	#keyMinus,d0		;subtract?
	bne.s	po6             
	move.l	accum(a5),d0
	sub.l	operand(a5),d0
	move.l	d0,accum(a5)
	bra.s	PerformOpExit	
po6	cmpi.b	#keyEqual,d0		;= ?
	bne.s	po7
	clr.l	op(a5)
	bne.s	PerformOpExit
po7	cmpi.b	#keyAND,d0		;AND from menu
	bne.s	po8
	move.l	operand(a5),d0
	and.l	d0,accum(a5)
	bra.s	PerformOpExit
po8	cmpi.b	#keyOR,d0		;OR from menu
	bne.s	po9
	move.l	operand(a5),d0
	or.l	d0,accum(a5)
	bra.s	PerformOpExit
po9	cmpi.b	#keyXOR,d0		;XOR from menu
	bne.s	PerformOpExit
	move.l	operand(a5),d0
	eor.l	d0,accum(a5)
PerformOpExit
	clr.b	operandAvail(a5)	;set to no operand
	move.l	operator(a6),op(a5)
PerformOpDone
endproc           

proc DrawBitmap(resource.w,x.w,y.w)
beginproc
	movem.l	a3,-(a7)
	move.l  #'Tbmp',d0
   	systrap DmGetResource(d0.l, resource(a6).w)
	cmp.l	#0,a0
	beq.s   DrawBitmapError
	move.l	a0,a3
	systrap MemHandleLock(a0.l)
	cmp.l	#0,a0
	beq.s	DrawBitmapError
	systrap WinDrawBitmap(a0.l,x(a6).w,y(a6).w)
	systrap MemHandleUnlock(a3.l)		
	systrap DmReleaseResource(a3.l)
DrawBitmapError
	movem.l	(a7)+,a3
endproc


proc UpdateDisplay()
local negFlag.l
local DisplayValue.l
local rect.RectangleType
beginproc
	clr.l	negFlag(a6)		
	tst.b	error(a5)		;error state?
	beq.s	UDNoErr
        systrap SndPlaySystemSound(#sndError.b)
	pea.l	ErrorString(a5)       	
	pea.l	DispString(a5)
	trap	#15
	dc.w	sysTrapStrCopy   
	bra.s	DoDisp
UDNoErr	move.l	accum(a5),DisplayValue(a6) ;display accum
	tst.b	operandAvail(a5)
	beq.s	UDOp			;unless operand is avail, then display that
	move.l	operand(a5),DisplayValue(a6)
UDOp	cmpi.l	#0,DisplayValue(a6)	;check if value	
	bpl.s	isPos			; is negative
	tst.b	DisplayMode(a5)		;and display mode is dec
	beq.s	isPos			;Dont negate if hex display mode
	neg.l	DisplayValue(a6)	;all conditions meet, then abs(value)	
	move.l	#1,negFlag(a6)		;set negative flag
isPos	move.l	DisplayValue(a6),-(a7)	;push value
	pea.l	DispString(a5)		;push string area address
	tst.b	DisplayMode(a5)
	beq.s	DoHex
	trap 	#15
	dc.w	sysTrapStrIToA		;Convert to decimal ascii
	bra.s	DoDisp
DoHex	trap 	#15
	dc.w	sysTrapStrIToH		;Convert to Hex ascii
DoDisp	addq.l	#8,a7
	move.w	#10,rect.topLeft.x(a6)
	move.w	#4,rect.topLeft.y(a6)
	move.w	#140,rect.extent.x(a6)
	move.w	#35,rect.extent.y(a6)
	systrap	WinEraseRectangle(&rect(a6),#0.w)
	move.w	#10,rect.topLeft.x(a6)
	move.w	#4,rect.topLeft.y(a6)
	move.w	#140,rect.extent.x(a6)
	move.w	#35,rect.extent.y(a6)
	systrap	WinDrawRectangleFrame(#5.w,&rect(a6))
	systrap	FntSetFont(#largeFont.b)
	tst.l	negFlag(a6)		;If negative, then cat a '-' to the display
	beq.s	DispPos
	pea.l	NegIndicator(a5)
	pea.l	DispString(a5)
	trap	#15
	dc.w	sysTrapStrCat
	addq.l	#8,a7
DispPos	pea.l	DispString(a5)
	trap	#15
	dc.w	sysTrapStrLen		;Get length of string
	addq.l	#4,a7
	move.l	d0,d5			;in d5
	systrap	FntCharsWidth(&DispString(a5),d5.w)
	move.w	#130,d1			;Make it pretty
	sub.w	d0,d1
	systrap	WinDrawChars(&DispString(a5),d5.w,d1.w,#16.w)
	systrap	FntSetFont(#stdFont.b)	;Font size large
	cmpi.b	#1,DisplayMode(a5)	;Draw appropriate 'Dec','Hex' label
	beq.s	lblDec
	systrap	WinDrawChars(&HexLbl(a5),#3.w,#15.w,#25.w)
	bra.s	UpdtOp
lblDec
	systrap	WinDrawChars(&DecLbl(a5),#3.w,#15.w,#25.w)
UpdtOp	move.l	op(a5),d0
	btst	#4,d0			;$10 and greater
	bne.s	MenuItemSelection	;draw 'AND', 'OR', 'XOR'
	btst	#2,d0			;$4, $5, $6, and $7
	beq.s	UpdateDisplayExit	
	move.w	#9,-(a7)		;draw '+','-','x', or '/'
	move.w	#14.w,-(a7)
	move.w	#1,-(a7)
	move.l	op(a5),d0
	sub.l	#4,d0
	pea.l	DisplayOp(a5,d0)
	bra.s   DrawOp
MenuItemSelection
	sub.l	#16,d0
	lsl.l	#2,d0			;calc offset in DisplayOpMenu		
	move.w	#9,-(a7)		;'+','-','x', or '/'
	move.w	#14.w,-(a7)
	move.w	#4,-(a7)
	pea.l	DisplayOpMenu(a5,d0)
DrawOp	trap 	#15
	dc.w	sysTrapWinDrawChars
	lea	10(a7),a7	
UpdateDisplayExit
endproc


;
; Button resources
;

        res 'WBMP', kidbAIB, "hexc.bmp"
        res 'WBMP', kidbBMP, "blank.bmp"
	res 'WBMP', kidbCE, "ce.bmp"
	res 'WBMP', kidbRSHIFT, "rshift.bmp"
	res 'WBMP', kidbLSHIFT, "lshift.bmp"
	res 'WBMP', kidbNEG, "neg.bmp"
        res 'WBMP', kidbCLR, "clr.bmp"
        res 'WBMP', kidbDEC, "dec.bmp"
        res 'WBMP', kidbHEX, "hex.bmp"
        res 'WBMP', kidbEQUAL, "equal.bmp"
        res 'WBMP', kidbADD, "add.bmp"
        res 'WBMP', kidbSUB, "sub.bmp"
        res 'WBMP', kidbMULT, "mult.bmp"
        res 'WBMP', kidbDIV, "div.bmp"
        res 'WBMP', kidbBMP0, "zero.bmp"
        res 'WBMP', kidbBMP1, "one.bmp"
        res 'WBMP', kidbBMP2, "two.bmp"
        res 'WBMP', kidbBMP3, "three.bmp"
        res 'WBMP', kidbBMP4, "four.bmp"
        res 'WBMP', kidbBMP5, "five.bmp"
        res 'WBMP', kidbBMP6, "six.bmp"
        res 'WBMP', kidbBMP7, "seven.bmp"
        res 'WBMP', kidbBMP8, "eight.bmp"
        res 'WBMP', kidbBMP9, "nine.bmp"
        res 'WBMP', kidbBMPA, "a.bmp"
        res 'WBMP', kidbBMPB, "b.bmp"
        res 'WBMP', kidbBMPC, "c.bmp"
        res 'WBMP', kidbBMPD, "d.bmp"
        res 'WBMP', kidbBMPE, "e.bmp"
        res 'WBMP', kidbBMPF, "f.bmp"
;
; 'pref' resource. Defines app launch flags, stack and heap size
;
        res 'pref', kidrPREF
        dc.w    sysAppLaunchFlagNewStack|sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp|sysAppLaunchFlagSubCall
        dc.l    $1000                           ; stack size
        dc.l    $1000                           ; heap size
;
; Form resource
;
        res 'tFRM', kidfMain, "tfrm03e8.bin"

;
; Version resource
;
        res 'tver', kidrTVER
        dc.b    '1.0', 0
;
; Menu resource
;
        res 'MBAR', kidmMain, "mbar03e8.bin"
;
; About alert
;
	res 'Talt', kidrAboutAlert,"talt03e8.bin"
